#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "tsp4.h"



/* Restituisce la distanza tra 2 punti */
Dist d(int i, int j) {
	 Dist d = 0;
	 int x1,x2,y1,y2;
	 int dx,dy;
	 
	 x1= cityarray[i]->x;
	 y1=cityarray[i]->y;
	 
	 x2=cityarray[j]->x;
	 y2=cityarray[j]->y;

	/* Calcolo la distanza*/
	dx = (x1 > x2) ? (x1-x2) : (x2-x1) ;
	dy = (y1 > y2) ? (y1-y2) : (y2-y1);
	
	/* Radice quadrata dei quadrati delle distanze*/
	d = sqrt(dx*dx + dy*dy);
	
	return d;
}

/* Legge le citta' dall' input e memorizza le coordinate nel vettore cityarray*/
int getCities(int ncities, char **coordinates){
	/* indice arrai citta' */
	int i = 0;
	/* indice parametri commandline*/
	int j = 1;
	
	while(i <ncities) {
		cityarray[i] = (t_city *) malloc (sizeof(t_city));
		cityarray[i]->x =  atoi(coordinates[j++]);
		cityarray[i]->y =  atoi(coordinates[j++]);
		
		i++;
	}
	
	return 0;
}



 void swap(int i, int j) {
	int t=0;
	
	t = permutation[i];
	permutation [i] = permutation[j];
	permutation[j] = t;
 }
 
 void solve3()
 { 
	search3(ncities-1, 0);
 }
 
 void search3(int m, Dist sum) { 
	int i;
 
	if (sum > minsum)
		return;

	if (m == 1)
		check3(sum + d(permutation[0], permutation[1]));
	else
		for (i = m-1; i >= 0; i--) {
			swap(i, m-1);
			search3(m-1, sum + d(permutation[m-1], permutation[m]));
			swap(i, m-1);
    }

}

 void check3(Dist sum)
 { 
	sum += d(permutation[0], permutation[ncities-1]);
    save(sum);
 }



void save(Dist sum)
 { 
	int i;
    if (sum < minsum) {
		minsum = sum;
		for (i = 0; i < ncities; i++)
			minp[i] = permutation[i];
    }
 }


int main (int argc, char **argv) {
	ncities = argc / 2;
	int i = 0;
	
	permutation = (int *) malloc (ncities * sizeof(int ));
	cityarray = (t_city **) malloc (ncities * sizeof(t_city *));
	minp= (int *) malloc (ncities * sizeof(int));
	minsum = 1000;
	
	getCities(ncities,argv);
	
	for (i = 0; i < ncities; i++) 
		permutation[i] = i;
		
	solve3(ncities);
	
	free(permutation);
	free(cityarray);
	
	printf("Lunghezza percorso minimo: %.2f\n",minsum);
 
 }

